=== debian/changelog ===
megaglest (3.11.0+dfsg-2) unstable; urgency=medium

  * Upload to unstable.
  * debian/rules: Insert CountryTexturePath in glest.ini and use a dh_install
    override for it.
  * Switch to new fonts packages fonts-dejavu-core and fonts-wqy-zenhei.
  * Remove libxerces-c-dev from Build-Depends.

 -- Markus Koschany <apo@gambaru.de>  Fri, 06 Feb 2015 20:09:26 +0100

megaglest (3.11.0+dfsg-1) experimental; urgency=medium

  * Imported Upstream version 3.11.0+dfsg.
  * Remove prebuilt windows dll file with Files-Excluded mechanism.
  * Add get-orig-source target and repack the source tarball.
  * Move the package to Git.
  * debian/control:
    - Use Architecture: any. Try to build on all available architectures again.
    - Adjust the dependency on megaglest-data to >= 3.11.0.
  * Drop fix-cmake-build-type-none.patch. Merged upstream.
  * Drop wxWidgets-assertions.patch. Merged upstream.
  * Update clean file and clean only required files, not the complete mk/linux
    directory. This prevents a FTBFS.
  * Update debian/copyright for new release.
  * Drop source/lintian-overrides. It is obsolete now.
  * Drop megaglest.dirs. The install files achieve the same.

 -- Markus Koschany <apo@gambaru.de>  Sat, 31 Jan 2015 17:51:32 +0100
