=== debian/control ===
Source: megaglest
Section: games
Priority: extra
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Mark Vejvoda <mark_vejvoda@hotmail.com>,
 Markus Koschany <apo@gambaru.de>
Build-Depends:
 cmake,
 debhelper (>= 9),
 help2man,
 libcppunit-dev,
 libcurl4-gnutls-dev | libcurl4-nss-dev,
 libfontconfig1-dev,
 libfribidi-dev,
 libftgl-dev,
 libglew-dev,
 libircclient-dev,
 libjpeg-dev,
 liblua5.1-0-dev,
 libminiupnpc-dev,
 libogg-dev,
 libopenal-dev,
 libpng-dev,
 libsdl1.2-dev,
 libvorbis-dev,
 libwxgtk3.0-dev,
 libxml2-dev,
 libz-dev,
 xauth,
 xvfb
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/pkg-games/megaglest.git
Vcs-Browser: http://anonscm.debian.org/cgit/pkg-games/megaglest.git
Homepage: http://megaglest.org/

Package: megaglest
Architecture: any
Depends:
 famfamfam-flag-png,
 fonts-liberation,
 fonts-uralic,
 megaglest-data (>= 3.11.0),
 p7zip-full,
 fonts-dejavu-core,
 fonts-wqy-zenhei,
 ${misc:Depends},
 ${shlibs:Depends}
Description: 3D multi-player real time strategy game
 MegaGlest is a free 3D real-time customizable strategy game
 which takes place in a context which could be compared to that of the
 pre-renaissance Europe, with the licence that magic forces exist in the
 environment and can be controlled.
 .
 The current version is fully playable and supports both single player
 games against CPU controlled players and multiplayer matches over the
 Internet or a LAN.

Package: megaglest-dbg
Section: debug
Architecture: any
Depends:
 megaglest (= ${binary:Version}),
 ${misc:Depends}
Description: debug files for MegaGlest
 This package contains debug information for the MegaGlest game.
 .
 It can be used to debug MegaGlest using GDB if the game crashes
 due to programming errors.
