=== debian/rules ===
#!/usr/bin/make -f
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
# Disable wxWidgets assertions
export DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
		-DMEGAGLEST_DATA_INSTALL_PATH=share/games/megaglest/ \
		-DWANT_DEV_OUTPATH=ON

override_dh_strip:
	dh_strip --dbg-package=megaglest-dbg

override_dh_installchangelogs:
	dh_installchangelogs docs/CHANGELOG.txt

override_dh_auto_clean:
	rm -rf mk/linux/mojosetup/
	dh_auto_clean

override_dh_install:
	dh_install
	# Remove empty directory
	$(RM) -r debian/megaglest/usr/share/games/megaglest/data
	echo \
		"CountryTexturePath=/usr/share/flags/countries/16x11/" >> \
		debian/megaglest/usr/share/games/megaglest/glest.ini

get-orig-source:
	uscan --verbose --repack --compression xz --force-download
